SystemOrganization addCategory: #'PharoBot-Environment-Tests'!

TestCase subclass: #PharoBotGlobalEnvironmentTest
	instanceVariableNames: 'env'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-Environment-Tests'!

!PharoBotGlobalEnvironmentTest commentStamp: '<historical>' prior: 0!
A PharoBotGlobalEnvironmentTest is a test class for testing the behavior of PharoBotGlobalEnvironment!

!PharoBotGlobalEnvironmentTest class methodsFor: 'accessing' stamp: 'NahuelGarbezza 12/22/2012 18:41'!
packageNamesUnderTest

	^#('PharoBot-Environment')! !

!PharoBotGlobalEnvironmentTest methodsFor: 'set up' stamp: 'NahuelGarbezza 7/14/2012 22:27'!
setUp

	PharoBotGlobalEnvironment clearInstance.
	env := PharoBotGlobalEnvironment instance.! !

!PharoBotGlobalEnvironmentTest methodsFor: 'set up' stamp: 'NahuelGarbezza 7/14/2012 22:29'!
tearDown

	(Smalltalk at: self tempClassName ifAbsent: [^self]) removeFromSystem! !

!PharoBotGlobalEnvironmentTest methodsFor: 'set up' stamp: 'NahuelGarbezza 7/14/2012 22:20'!
tempClassName

	^#PharoBotTempClass! !

!PharoBotGlobalEnvironmentTest methodsFor: 'adding classes' stamp: 'NahuelGarbezza 7/18/2012 17:33'!
testAddRobotClassShouldFailBecauseItIsDefault

	self
		should: [ env addClassNamed: #Robot ]
		raise: PharoBotEnvironmentError
		withExceptionDo: [ :e |
			self assert: e messageText = PharoBotEnvironmentError attemptToAddRobotClass ]! !

!PharoBotGlobalEnvironmentTest methodsFor: 'adding classes' stamp: 'NahuelGarbezza 7/14/2012 22:22'!
testAddingANewClass
	
	env addClassNamed: self tempClassName.
	
	self assert: (env hasClassNamed: self tempClassName).! !

!PharoBotGlobalEnvironmentTest methodsFor: 'adding classes' stamp: 'NahuelGarbezza 7/14/2012 22:28'!
testAddingANewClassIsCreatedInTheImage
	
	env addClassNamed: self tempClassName.
	
	self shouldnt: (Smalltalk at: self tempClassName) raise: Error.! !

!PharoBotGlobalEnvironmentTest methodsFor: 'accessing classes' stamp: 'NahuelGarbezza 7/14/2012 22:07'!
testDoesntHaveAClassName

	self deny: (PharoBotGlobalEnvironment instance hasClassNamed: #NonExistentClassXXX)! !

!PharoBotGlobalEnvironmentTest methodsFor: 'accessing classes' stamp: 'NahuelGarbezza 7/14/2012 22:22'!
testEnvironmentHasRobotClassByDefault

	self assert: (env hasClassNamed: #Robot)! !

!PharoBotGlobalEnvironmentTest methodsFor: 'singleton' stamp: 'NahuelGarbezza 7/14/2012 21:54'!
testGlobalEnvironmentIsSingleton

	self assert: PharoBotGlobalEnvironment instance == PharoBotGlobalEnvironment instance! !

!PharoBotGlobalEnvironmentTest methodsFor: 'accessing classes' stamp: 'NahuelGarbezza 8/20/2012 20:02'!
testItReturnClasses

	self assert: {Robot} asSet equals: env classes! !

!PharoBotGlobalEnvironmentTest methodsFor: 'adding classes' stamp: 'NahuelGarbezza 7/14/2012 22:31'!
testNewClassAddedInTheImageShouldExtendFromObject
	
	env addClassNamed: self tempClassName.
	
	self assert: (Smalltalk at: self tempClassName) superclass = Object.! !

!PharoBotGlobalEnvironmentTest methodsFor: 'removing classes' stamp: 'NahuelGarbezza 7/14/2012 22:49'!
testRemoveAClassInexistentShouldRaiseAnError

	self
		should: [ env removeClassNamed: self tempClassName ]
		raise: PharoBotEnvironmentError 
		withExceptionDo: [ :e | self assert: e messageText = PharoBotEnvironmentError attemptToRemoveInexistentClass  ]! !

!PharoBotGlobalEnvironmentTest methodsFor: 'removing classes' stamp: 'NahuelGarbezza 7/14/2012 22:54'!
testRemoveAClassRecentlyAdded

	env addClassNamed: self tempClassName.
	env removeClassNamed: self tempClassName.
	
	self deny: (env hasClassNamed: self tempClassName)! !

!PharoBotGlobalEnvironmentTest methodsFor: 'removing classes' stamp: 'NahuelGarbezza 7/14/2012 23:03'!
testRemoveAClassRecentlyAddedAlsoShouldRemoveItFromTheImage

	env addClassNamed: self tempClassName.
	env removeClassNamed: self tempClassName.
	
	self should: [ Smalltalk at: self tempClassName ] raise: Error.! !

!PharoBotGlobalEnvironmentTest methodsFor: 'removing classes' stamp: 'NahuelGarbezza 7/14/2012 22:44'!
testRobotClassCannotBeRemoved

	self
		should: [ env removeClassNamed: #Robot ]
		raise: PharoBotEnvironmentError
		withExceptionDo: [ :e |
			self assert: e messageText = PharoBotEnvironmentError cannotRemoveRobotClass ]! !
